
function Search() {
	var elt = document.getElementById('SearchUAI');
	document.location.href='?page=sds&host='+elt.value;
}

function formatDate(date) {
	const hours = String(date.getHours()).padStart(2, "0");
	const minutes = String(date.getMinutes()).padStart(2, "0");
	const day = String(date.getDate()).padStart(2, "0");
	const month = String(date.getMonth() + 1).padStart(2, "0"); // Les mois commencent à 0
	return `${day}/${month} - ${hours}:${minutes}`;
}

function GraphStats(quoi,i,fluxResponse)
{
	class PlotRenderer extends React.Component {
		render() {
			const style = {
				width: "calc(99%)",
				height: "calc(40vh)",
				margin: "0em",
			};
			const lineLayer = {
				type: "line",
				x: "_time",
				y: "_value",
				lineWidth: 2,
				fill: [],
				position: "overlaid",
				interpolation: "monotoneX",
				hoverDimension: "auto",
				shadeBelow: true,
				shadeBelowOpacity: 0.1,
			};
			const config = {
				fluxResponse,
				layers: [lineLayer],
				fluxResponse,
				xScale: "linear",
				yScale: "linear",
				legendColorizeRows: true,
				legendFont: "0.7em sans-serif",
				tickFont: "0.6em sans-serif",
				valueFormatters: {
					_time: (t) => formatDate(new Date(t)),
					_value: (num) => num.toFixed(2),
				},
			};
			const SimplePlot = React.createElement(Giraffe.Plot, {config}, null);
			return React.createElement("div", {style}, SimplePlot);
		}
	}
	ReactDOM.render(
		React.createElement(PlotRenderer),
		document.getElementById("ChargeServeurs"+i)
	);
}
