<?php

function form_search_user($config)
{
    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? "";
    if (! empty($etab)) {
        $value = "value = \"$etab\"";
    } else {
        $value = "";
    }
    /**
     * Si le host est passé en GET
     * inutile d'fficher l'input du host
     */
    $hidden = "type=\"text\"";
    if (! empty($_GET['host'])) {
        $hidden = "type =\"hidden\"";
    }

    $content = '<form class="d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search" method="post" action="index.php?page=r">
			<div class="input-group">
			<ul class="list-group">
			<li  class="list-group-item">
				<input name ="etab" class="form-control bg-light border-0
                                small" placeholder="Limiter à l\'établissement..." ' . $value . ' aria-label="Search" aria-describedby="basic-addon2"
                                list="list-UAI" ' . $hidden . ' >
			</li>
			<li class="list-group-item">
				<input type="text" class="form-control bg-light border-0 small" placeholder="Rechercher des utilisateurs..."
					aria-label="Search" aria-describedby="basic-addon2" name="searchUsers">
			</li>
			</ul>
				<div class="input-group-append">
					<button class="btn btn-primary" type="submit">
						<i class="fas fa-search fa-sm"></i>
					</button>
				</div>
			</div>
		</form>';
    return $content;
}

function form_search_group($config)
{
    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? "";
    if (! empty($etab)) {
        $value = "value = \"$etab\"";
    } else {
        $value = "";
    }
    /**
     * Si le host est passé en GET
     * inutile d'fficher l'input du host
     */
    $hidden = "type=\"text\"";
    if (! empty($_GET['host'])) {
        $hidden = "type =\"hidden\"";
    }

    $content = '<form class="d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search" method="post" action="index.php?page=r">
			<div class="input-group">
			<ul class="list-group">
			<li  class="list-group-item">
				<input name ="etab"  class="form-control bg-light border-0
                                 small" placeholder="Limiter à l\'établissement..." ' . $value . ' aria-label="Search" aria-describedby="basic-addon2"
                                list="list-UAI" ' . $hidden . ' >
			</li>
			<li class="list-group-item">
				<input type="text" class="form-control bg-light border-0 small" placeholder="Rechercher un groupe..."
					 aria-label="SearchGrp" aria-describedby="basic-addon2" name="searchGroups">
			</li>
			</ul>
				<div class="input-group-append">
					<button class="btn btn-primary" type="submit">
						<i class="fas fa-search fa-sm"></i>
					</button>
				</div>
			</div>
		</form>';

    return $content;
}

function form_list_parc($config, $etab)
{
    $nb_etab = count(activated_etabs($config));
    $list_parcs = search_parcs(get_config($config, true, $etab), "*");
    // print_r($list_parcs);
    $content = "";
    $content .= "<FORM  method=\"post\"  class=\"d-none d-sm-inline-block form-inline mr-auto ml-md-2 my-2 my-md-2 mw-100 navbar-search\" action=\"show_parc.php\">\n";
    $content .= "<div class=\"input-group\">";
    $content .= "<SELECT NAME=\"parc\"  class=\"form-control bg-light border-0 small\" aria-label=\".form-select-lg\" onchange=submit()>";
    $content .= "<option value=\"\">Sélectionner</option>";
    foreach ($list_parcs as $value_tmp) {
        if (! empty($value_tmp["samaccountname"])) {
            $content .= "<option value=\"" . $value_tmp["samaccountname"] . "\"";
            $nom_etab = "";
            $content .= ">" . $value_tmp["name"] . " " . " de type " . $value_tmp["type"] . $nom_etab . "\n";
            $content .= "</option>";
        }
    }
    $content .= "</SELECT></div></form>";
    return $content;
}

function annu_central($config, &$html)
{
    $html .= '<div class="row">';
    $titre = 'Recherche d\'utilisateurs dans l\'annuaire (4 lettres minimum)';
    $content = form_search_user($config);
    $html .= html_box(6, 6, 4, "success", $titre, $content, "fas fa-address-card fa-3x");
    $titre = 'Recherche d\'un groupe dans l\'annuaire (3 lettres minimum)';
    $content = form_search_group($config);
    $html .= html_box(6, 6, 4, "success", $titre, $content, "fas fa-users fa-3x");
    $html .= "</div>";

    $etab = $_POST['etab'] ?? $_GET['etab'] ?? $_POST['host'] ?? $_GET['host'] ?? "";
    /**
     * Résultat de la recherche
     */
    $searching = $_POST['searchUsers'] ?? "";
    $searchingGrp = $_POST['searchGroups'] ?? "";

    if ((! empty($searchingGrp)) && (strlen($searchingGrp) > 2)) {

        $result = search_ad($config, "*$searchingGrp*", 'group', $config['dn']['groups']);
        // $result = filter_group($config, "*$searchingGrp*");

        // print_r($result);
        // exit;

        $content = "";
        $grps = [];
        if (! empty($result)) {
            foreach ($result as $key => $value) {
                if (($etab == "") || ($value['etab'] == $etab)) {
                    $grps['etab'] = $value['etab'];
                    $grps['cn'] = $value['cn'];
                    $grps['dn'] = $value['dn'];
                    $content .= "<li class=\"small\">" . "<a href=\"?page=r&grp=" . urlencode($grps['dn']) . "\" >" . $grps['cn'] . " (" . $grps['etab'] . ")" . "</a></li>";
                }
            }
            $titre = "Il y a " . count($grps) . " résultats pour la recherche pour \"<b>" . $searchingGrp . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, $content, "far fa-address-card fa-3x");
        } else {
            $titre = "Il n'y a aucun résultat pour la recherche pour \"<b>" . $searchingGrp . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, "", "far fa-address-card fa-3x");
        }
    }
    if ((! empty($searching)) && (strlen($searching) > 3)) {
        $_SESSION['etab_ou'] = $etab;
        $result = search_ad($config, "(cn=*$searching*)", "filter", $config['dn']['people'], [
            'cn',
            'dn',
            'fullname',
            'pwdlastset'
        ]);
        $content = "   ";
        $users = [];
        if (! empty($result)) {
            foreach ($result as $key => $value) {
                if (($etab == "") || ($value['etab'] == $etab)) {
                    if ($value['pwdlastset'] != 0) {
                        $userActivated = "activé";
                    } else {
                        $userActivated = "non activé";
                    }
                    $users[$key] = search_user($config, $value["cn"]);
                    $userUai = $value["etab"];
                    $userCategorie = explode("=", explode(",", $value["dn"])[1])[1];
                    [
                        $Nom,
                        $Prenom
                    ] = explode(" ", $value["fullname"]);
                    $content .= "<li class=\"small\">" . "<a href=\"?page=r&cn=" . $value["cn"] . "\" >" . ucfirst(strtolower($Nom)) . " " . ucfirst(strtolower($Prenom)) . " (" . $value["cn"] . ", " . $userUai . ", " . $userCategorie . ", $userActivated)" . "</a></li>";
                }
            }
            $titre = "Il y a " . count($users) . " résultats pour la recherche pour \"<b>" . $searching . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, $content, "far fa-address-card fa-3x");
        } else {
            $titre = "Il n'y a aucun résultat pour la recherche pour \"<b>" . $searching . "</b>\"";
            $html .= html_box(12, 6, 4, "secondary", $titre, "", "far fa-address-card fa-3x");
        }
    }
    /**
     * Fiche utilisateur après choix
     */
    if (! empty($_GET['cn'])) {
        $html .= "<!-- DEBUT -->";
        $titre = "Fiche de l'utilisateur " . $_GET['cn'];
        $content = "";
        people_html($config, $content);

        $html .= '<div class="row">
				<div class="col-xl-12 col-lg-7 ">
					<div class=" card shadow mb-4">
						<div
							class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
							<h6 class="m-0 font-weight-bold text-primary">' . $titre . '</h6>
						</div>
						<div class="card-body ">' . $content . '				</div>
					</div>
				</div>
			</div>';
    } elseif (! empty($_GET['grp'])) {
        $_GET['filter'] = $_GET['grp'];
        $html .= "<!-- DEBUT -->";
        $titre = "Groupe  : " . ldap_dn2cn($_GET['grp']);
        $content = "";
        group_html($config, $content);

        $html .= '<div class="row">
				<div class="col-xl-12 col-lg-7 ">
					<div class=" card shadow mb-4">
						<div
							class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
							<h6 class="m-0 font-weight-bold text-primary">' . $titre . '</h6>
						</div>
						<div class="card-body ">' . $content . '				</div>
					</div>
				</div>
			</div>';
    }
}
?>